program crash_cars;

uses dos,crt,vga256c,secpage,lesen,timer,manykeys;

const lw='e:\bp\crash\';
      unt:array [0..6] of byte=(2,2,2,2,1,1,1);
      drehmax=2;
      maxgas=6;
      schleudermax=5;
      maxlaps=3;
      bremsmax=2;
      gasmax=2;
      sh16x16anz=128;
      maxpeople=17;
      maxexanz=20;
      rix:array [1..16] of shortint=
                (0,-7,-14,-18,-20,-18,-14,-7,0,7,14,18,20,18,14,7);
      riy:array [1..16] of shortint=
                (-20,-18,-14,-7,0,7,14,18,20,18,14,7,0,-7,-14,-18);
      mbew:array [0..5] of byte=(0,1,2,3,2,1);
      bew:array [0..11] of byte=(0,0,1,1,2,2,3,3,4,4,5,5);
      downpic:array [1..3] of byte=(9,11,9);
      maxmonster=150;
      maxmusic=5;
      tuerreinmax=20;
      musics:array [1..maxmusic,1..20] of byte=
            ((20,21,22,23,24, 25,26,27,28,29, 255,0,0,0,0, 0,0,0,0,0),
             (2,3,255,0,0,    0,0,0,0,0,      0,0,0,0,0,   0,0,0,0,0),
             (40,40,44,44,44, 255,0,0,0,0,    0,0,0,0,0,   0,0,0,0,0),
             (20,24,28,255,0, 0,0,0,0,0,      0,0,0,0,0,   0,0,0,0,0),
             (80,80,255,0,0,  0,0,0,0,0,      0,0,0,0,0,   0,0,0,0,0));

type bild=array [1..260] of byte;
     bild2=array [1..404] of byte;
     bfile=file of byte;
     tmonster=record
               art:byte;
               x,y:word;
               da:boolean;
              end;
     texpl=record
            x,y:word;
            art:byte;
            da:boolean;
           end;

var a:char;
    feld:array [1..100,1..100] of byte;
    feld2,mfeld:array [1..20,1..20] of byte;
    pic:array [0..sh16x16anz] of bild;
    people:array [1..maxpeople] of pointer;
    expl:array [1..maxexanz] of texpl;
    mfanz,lap,
    fanz,schleuderri,schleudergas,schleuderz,gasz,bremsz,dreh,hx,hy:byte;
    zdx,zdy,ddx,ddy,zx,zy,dx,dy:integer;
    rcount,anx,any,gas,anfy,x,y,rx,ry,anfx,i,j:word;
    bz1,bz2,kmz,monstanz,stones,
    tuerrein,amulette,treffer,health,mysanz,maxmysanz,hissanz,
    runt,saz,level,nlevel,
    sanz,exanz,shot,blink,
    actnote,actmusic,manz,playerpic,smz,bewz,ri:byte;
    umenu,ganzaus,tuerauf,schleudern,starten,auslauf,
    wsprung,tot,music,bonus,leveldone,done,sprung,be,aus:boolean;
    fbuf:array [1..2048] of byte;
    pbuf:pointer;
    monster:array [1..maxmonster] of tmonster;
    laptime,anfzeit,oscore,score:longint;
    lapzeit:array [1..3] of longint;
    hs:string;

{ ***************** Variablen initialisieren / Shapes laden ****************}

procedure init;
var f:file;
    p:palette;
    hvw:word;
    hpic:array [1..629] of byte;
 begin
  graphmode;
  randomize;
  assign(f,lw+'people.dat');
  reset(f,1);
  seek(f,404);
  for i:=1 to maxpeople do
   begin
    getmem(people[i],404);
    blockread(f,people[i]^,404);
   end;
  close(f);
  assign(f,lw+'mario.tex');
  reset(f,1);
  blockread(f,fbuf,2048);
  close(f);
  pbuf:=@fbuf;
  assign(f,lw+'lev.dat');
  reset(f,1);
  seek(f,260);
  for i:=1 to sh16x16anz do
   blockread(f,pic[i],260);
  close(f);
  wsprung:=false;
  assign(f,lw+'todd2.pal');
  reset(f,1);
  blockread(f,p,768);
  close(f);
  setpalette(p,0,255);
 end;

{****************************************************************************}
{** Befehle fr dynamischen Bildshirm                                      **}
{** =Bildshirm 64kB Auflsung 256x256                                      **}
{****************************************************************************}

{ *************** Shape BG auf virtuellen Bildschirm ************************}

Procedure PutBG(X,Y:Word;var BitMap); assembler;
asm
    push  ES
     push  DS
      push  DI
       push  SI

    { Ofs(X,Y) in DX }
    mov   DX,X
    mov   BX,Y
    mov   DH,BL

    { Segmente }
    Mov   AX,page2
    Mov   ES,AX
    LDS   SI,BitMap

    { BL=dx, BH=dy / addiere zu DX=Ofx(X,Y) (dx/2,dy/2) }
    LodSW
    Mov   BL,AL
    LodSW
    Mov   BH,AL

    { DX=Ofs(X,Y) in AX }
    mov   AX,DX

    XOr   CH,CH
    mov   CL,BH

    { Bewegen }
@P1:mov   BH,CL
     mov   DI,DX
      Mov   CL,BL
@P2:  LodSB
      Cmp   AL,0
      JE    @P4
      StoSB
@P3:  Loop  @P2
      Rep   MovSB
     mov   CL,BH
    inc   DH
    Loop  @P1

       pop   SI
      pop   DI
     pop   DS
    pop   ES
    Jmp   @PE

@P4:Inc   DI
    Jmp   @P3
@PE:
end;

{ *************** Shape BG auf virtuellen Bildschirm spiegeln ***************}

Procedure Putbgmirror(X,Y:Word;var BitMap); assembler;
asm
    Push  ES
    Push  DS

    { Ofs (X,Y) in DI }
    Mov   Dx,X
    Mov   bX,y
    mov   dh,bl
    mov   di,dx

    { Segmente }
    Mov   AX,page2
    Mov   ES,AX
    LDS   SI,BitMap

    { BX=dx, DX=dy }
    LodSW
    Mov   BX,AX
    LodSW
    Mov   DX,AX
    add di,bx
    dec di

    { Bewegen }
    Mov   CX,DX
@P1:Push  CX
     Push  DI
      Mov   CX,BX
@P2:  LodSB
      Cmp   AL,0
      JE    @P4
      StoSB
      dec di
      dec di
@P3:  Loop  @P2
     Pop   DI
    Pop   CX
    Add   DI,256
    Loop  @P1

    Pop   DS
    Pop   ES
    jmp @pe

@p4:dec di
    jmp @p3

@pe:
end;

{ *************** Shape BG+1Color auf virtuellen Bildschirm *****************}

Procedure Put1Color(X,Y:Word;Color:Byte;var BitMap); assembler;
asm
    push  ES
     push  DS
      push  DI
       push  SI

    { Ofs(X,Y) in DX }
    mov   DX,X
    mov   BX,Y
    mov   DH,BL

    mov   CL,Color

    { Segmente }
    Mov   AX,page2
    Mov   ES,AX
    LDS   SI,BitMap

    { BL=dx, BH=dy / addiere zu DX=Ofx(X,Y) (dx/2,dy/2) }
    LodSW
    Mov   BL,AL
    LodSW
    Mov   BH,AL

    { DX=Ofs(X,Y) in AX }
    mov   AX,DX

    { Color=CL in AH }
    mov   AH,CL

    XOr   CH,CH
    mov   CL,BH

    { Bewegen }
@P1:mov   BH,CL
     mov   DI,DX
      Mov   CL,BL
@P2:  LodSB
      Cmp   AL,0
      JE    @P4
      mov   AL,AH
      StoSB
@P3:  Loop  @P2
      Rep   MovSB
     mov   CL,BH
    inc   DH
    Loop  @P1

       pop   SI
      pop   DI
     pop   DS
    pop   ES
    Jmp   @PE

@P4:Inc   DI
    Jmp   @P3

@PE:
end;

{ ********** Shape BG+1Color auf virtuellen Bildschirm spiegeln ************}

Procedure Put1colormirror(X,Y:Word;color:byte;var BitMap); assembler;
asm
    Push  ES
    Push  DS

    { Ofs (X,Y) in DI }
    Mov   Dx,X
    Mov   bX,y
    mov   dh,bl
    mov   di,dx

    { Segmente }
    Mov   AX,page2
    Mov   ES,AX
    LDS   SI,BitMap

    { BX=dx, DX=dy }
    LodSW
    Mov   BX,AX
    LodSW
    Mov   DX,AX
    add di,bx
    dec di
    mov dl,color

    { Bewegen }
    Mov   CX,DX
@P1:Push  CX
     Push  DI
      Mov   CX,BX
@P2:  LodSB
      Cmp   AL,0
      JE    @P4
      mov   al,dl
      StoSB
      dec di
      dec di
@P3:  Loop  @P2
     Pop   DI
    Pop   CX
    Add   DI,256
    Loop  @P1

    Pop   DS
    Pop   ES
    jmp @pe

@p4:dec di
    jmp @p3

@pe:
end;

{ ********** Shape (16x16) auf virtuellen Bildschirm ***********************}

Procedure Put16x16(X,Y:Word;var BitMap); assembler;
asm
    push  ES
     push  DS
      push  DI
       push  SI

    { Ofs(X,Y) in DX }
    mov   DX,X
    mov   BX,Y
    mov   DH,BL

    { Segmente }
    Mov   AX,page2
    Mov   ES,AX
    LDS   SI,BitMap
    inc   si
    inc   si
    inc   si
    inc   si
    { DX=Ofs(X,Y) in AX }
    mov   AX,DX

    XOr   CH,CH
    mov   CL,16

@P1:mov   BH,CL
     mov   DI,AX
      Mov   CL,8
      Rep   MovSW
     mov   CL,BH
    inc   AH
    Loop  @P1

       pop   SI
      pop   DI
     pop   DS
    pop   ES

end;

{ ********** Zahl in String mit fhrenden Spaces ***************************}

procedure strr(hv:word;var s:string;l:byte);
 begin
  str(hv,s);
  s:=copy('          '+s,length(s)+11-l,l);
 end;

{ ********** Zahl in String mit fhrenden Nullen ***************************}

procedure strr2(hv:word;var s:string;l:byte);
 begin
  str(hv,s);
  s:=copy('0000000000'+s,length(s)+11-l,l);
 end;

{ ********** Ausgabe fr TEX-Fonts *****************************************}

procedure printt(x,y,f,b:word;text:string);
const h:array [0..7] of byte=(128,64,32,16,8,4,2,1);
var hv4,hv3,hv2,i,hv:word;
    c:byte;
 begin
  hv2:=f;
  hv3:=b;
  for i:=1 to length(text) do
   begin
    c:=ord(text[i]);
    asm
     xor bh,bh
     mov bl,c
     shl bx,1
     shl bx,1
     shl bx,1
     dec bx
     mov cx,0
     lds si,pbuf
   @loop1:
     mov hv,0
     mov ax,128
     inc bx
     xor dh,dh
   @loop4:
     push ds
      mov dl, ds:[si+bx]
     pop ds
     shr ax,1
     inc hv
     and dx,ax
     cmp dx,ax
     je @set
     jmp @noset
   @loop3:
     cmp ax,2
     jne @loop4
     inc cx
     cmp cx,7
     jne @loop1
     jmp @end
   @set:
     push ax
     mov ax,hv2
     mov hv4,ax
     pop ax
     jmp @dopixel
   @noset:
     push ax
     mov ax,hv3
     mov hv4,ax
     pop ax
   @dopixel:
      push ax
      push bx
      push dx
      push es
       mov   ax,graphseg
       Mov   ES,AX
       Mov   AX,y
       add   ax,cx
       Mov   DX,320
       IMul  DX
        push cx
         mov cx,i
         add cx,i
         add cx,i
         add cx,i
         add cx,i
         add cx,i
         add   ax,cx
         add   ax,hv
         add   ax,x
         mov   di,ax
         mov   cx,hv4
         Mov   Byte Ptr ES:[DI],cl
        pop cx
      pop es
      pop dx
      pop bx
      pop ax
     jmp @loop3
   @end:
    end;
   end;
 end;

{ ************* Virtuellen Bildschirm auf Grafikkarte kopieren *************}

procedure MakeScreen; assembler;
asm
    push  ES
     push  DS
      push  SI
       push  DI

    mov   SI,22*256+40      { Ecke links oben virtuell }
    mov   DI,10*320+10     { Ecke links oben }

    mov   CX,168           { Y-Ausdehnung }
    mov   BX,64

    { Segmente }
    Mov   AX,page2
    Mov   DS,AX
    Mov   AX,$a000
    Mov   ES,AX

    xor   CH,CH

    { Bewegen }
@G1:mov   DL,CL
     Mov   CL,106           { X-Ausdehnung/2 }
     Rep   MovSW
    mov   CL,DL
    add   DI,108            { 320-dX }
    add   SI,44             { 256-dX }
    Loop  @G1

       pop   DI
      pop   SI
     pop   DS
    pop   ES
end;

{ ************* Virtuellen Bildschirm aufbauen *****************************}

procedure makepic(anfx,zx,anfy,zy:word);
var
  X,Y: word;
 begin
  for x:=0 to 14 do
   for y:=0 to 11 do
    Put16x16(x*16+zx+24,y*16+zy+4,pic[feld[anfx+x,anfy+y+1]]);
 end;

{ ****************** Aktuellen Soundeffekt whlen **************************}

procedure muse(nr:byte);
 begin
  music:=true;
  actnote:=0;
  actmusic:=nr;
 end;

{ ************* Auf der Strecke ? ******************************************}

function drauf(hdx,hdy:word):boolean;
 begin
  drauf:=feld[hdx,hdy] in [6,7,9,10,12,14,22,23,26,28,31,36,38,41,42,46,48,50,52,53,
                           68..71,73,75,80,82];
 end;

{ **************** Neue Explosion einordnen ********************************}

procedure new_explosion(x,y:word);
var hv:byte;
 begin
  if exanz=maxexanz then exit;
  hv:=0;
  repeat
   inc(hv);
  until not expl[hv].da;
  muse(2);
  expl[hv].da:=true;
  expl[hv].x:=x;
  expl[hv].y:=y;
  expl[hv].art:=71;
  inc(exanz);
 end;

{********************************** Explosionen ****************************}

procedure explosions;
var i:byte;
 begin
  if exanz=0 then exit;
  for i:=1 to maxexanz do
   if expl[i].da then
    begin
     inc(expl[i].art);
     if expl[i].art=79 then
      begin
       expl[i].da:=false;
       dec(exanz);
      end;
     if expl[i].da then
      if (expl[i].x>=anx) and (expl[i].x<anx+256) and (expl[i].y>=any+16)
         and (expl[i].y<any+208) then
        putbg(expl[i].x-anx+22,expl[i].y-any-16,people[expl[i].art]^);
    end;
 end;

{ **************** Monster bewegen und anzeigen ****************************}

procedure otherpeople;             { Monster }
var i:byte;
    nixx:boolean;
 begin
  if manz=0 then exit;
  for i:=1 to manz do
   if monster[i].da then
    if (monster[i].x>=anx) and (monster[i].x<anx+256) and (monster[i].y>=any+16)
      and (monster[i].y<any+208) then
       begin
        putbg(monster[i].x-anx+22,monster[i].y-any-16,
                   people[monster[i].art]^);
       end;
 end;

{ **************** In Monster gerannt ? ************************************}

procedure crashtest;
var i:byte;
 begin
  for i:=1 to manz do
   if monster[i].da then
    if monster[i].art in [17] then
     if (abs(integer(monster[i].x-x))<12) and (abs(integer(monster[i].y-y))<12) then
      begin
       if monster[i].art=17 then   { lfleck }
        begin
         schleudern:=true;
         schleudergas:=gas+1;
         schleuderri:=ri;
         schleuderz:=0;
        end;
      end;
 end;

{ ***************** Level laden ********************************************}

function loadlevel(nlevel:byte):boolean;
const teilz=14;
type  tteil=array [1..5,1..5] of byte;
var hs:string;
    f,mf:file of byte;
    k,l,i,j:integer;
    nhx,nhy,hhx,hhy:byte;
    teil:array [1..teilz] of tteil;
 begin
  nhx:=8;
  nhy:=8;
  ri:=1;
  for i:=1 to teilz do
   for j:=1 to 5 do
    for k:=1 to 5 do
     teil[i,j,k]:=1;
  for i:=1 to 5 do
   begin
    teil[12,i,3]:=10;
    teil[14,i,3]:=10;
    teil[13,i,1]:=1;
    teil[13,i,2]:=16;
    teil[13,i,3]:=10;
    teil[13,i,4]:=17;
    teil[13,i,5]:=1;
    for j:=1 to 5 do
     begin
      teil[1,i,j]:=1;
      if i=1 then
       begin
        teil[2,i,j]:=18;
        teil[3,j,i]:=16;
        teil[8,i,j]:=18;
        teil[9,i,j]:=18;
        teil[10,j,i]:=16;
        teil[11,j,i]:=16;
       end;
      if (i>1) and (i<5) then
       begin
        teil[2,i,j]:=10;
        teil[3,j,i]:=10;
        teil[8,i,j]:=10;
        teil[9,i,j]:=10;
        teil[10,j,i]:=10;
        teil[11,j,i]:=10;
       end;
      if i=5 then
       begin
        teil[2,i,j]:=19;
        teil[3,j,i]:=17;
        teil[8,i,j]:=19;
        teil[9,i,j]:=19;
        teil[10,j,i]:=17;
        teil[11,j,i]:=17;
       end;
     end;
   end;
  teil[4,1,1]:=1;
  teil[4,2,1]:=1;
  teil[4,3,1]:=1;
  teil[4,4,1]:=2;
  teil[4,5,1]:=3;
  teil[4,2,2]:=4;
  teil[4,3,2]:=5;
  teil[4,4,2]:=6;
  teil[4,5,2]:=7;
  teil[4,2,3]:=8;
  teil[4,3,3]:=9;
  teil[4,4,3]:=10;
  teil[4,5,3]:=10;
  teil[4,1,4]:=11;
  teil[4,2,4]:=12;
  teil[4,3,4]:=10;
  teil[4,4,4]:=10;
  teil[4,5,4]:=10;
  teil[4,1,5]:=13;
  teil[4,2,5]:=14;
  teil[4,3,5]:=10;
  teil[4,4,5]:=10;
  teil[4,5,5]:=15;
  teil[5,1,1]:=20;
  teil[5,2,1]:=21;
  teil[5,3,1]:=1;
  teil[5,4,1]:=1;
  teil[5,5,1]:=1;
  teil[5,1,2]:=22;
  teil[5,2,2]:=23;
  teil[5,3,2]:=24;
  teil[5,4,2]:=25;
  teil[5,5,2]:=1;
  teil[5,1,3]:=10;
  teil[5,2,3]:=10;
  teil[5,3,3]:=26;
  teil[5,4,3]:=27;
  teil[5,5,3]:=1;
  teil[5,1,4]:=10;
  teil[5,2,4]:=10;
  teil[5,3,4]:=10;
  teil[5,4,4]:=28;
  teil[5,5,4]:=29;
  teil[5,1,5]:=30;
  teil[5,2,5]:=10;
  teil[5,3,5]:=10;
  teil[5,4,5]:=31;
  teil[5,5,5]:=32;
  teil[6,1,1]:=33;
  teil[6,2,1]:=10;
  teil[6,3,1]:=10;
  teil[6,4,1]:=10;
  teil[6,5,1]:=34;
  teil[6,1,2]:=35;
  teil[6,2,2]:=36;
  teil[6,3,2]:=10;
  teil[6,4,2]:=10;
  teil[6,5,2]:=10;
  teil[6,1,3]:=1;
  teil[6,2,3]:=37;
  teil[6,3,3]:=38;
  teil[6,4,3]:=10;
  teil[6,5,3]:=10;
  teil[6,1,4]:=1;
  teil[6,2,4]:=39;
  teil[6,3,4]:=40;
  teil[6,4,4]:=41;
  teil[6,5,4]:=42;
  teil[6,1,5]:=1;
  teil[6,2,5]:=1;
  teil[6,3,5]:=1;
  teil[6,4,5]:=43;
  teil[6,5,5]:=44;
  teil[7,1,1]:=45;
  teil[7,2,1]:=10;
  teil[7,3,1]:=10;
  teil[7,4,1]:=46;
  teil[7,5,1]:=47;
  teil[7,1,2]:=10;
  teil[7,2,2]:=10;
  teil[7,3,2]:=10;
  teil[7,4,2]:=48;
  teil[7,5,2]:=49;
  teil[7,1,3]:=10;
  teil[7,2,3]:=10;
  teil[7,3,3]:=50;
  teil[7,4,3]:=51;
  teil[7,5,3]:=1;
  teil[7,1,4]:=52;
  teil[7,2,4]:=53;
  teil[7,3,4]:=54;
  teil[7,4,4]:=55;
  teil[7,5,4]:=1;
  teil[7,1,5]:=56;
  teil[7,2,5]:=57;
  teil[7,3,5]:=1;
  teil[7,4,5]:=1;
  teil[7,5,5]:=1;
  teil[8,2,3]:=68;
  teil[8,3,3]:=68;
  teil[8,4,3]:=68;
  teil[9,2,3]:=69;
  teil[9,3,3]:=69;
  teil[9,4,3]:=69;
  teil[10,3,2]:=70;
  teil[10,3,3]:=70;
  teil[10,3,4]:=70;
  teil[11,3,2]:=71;
  teil[11,3,3]:=71;
  teil[11,3,4]:=71;
  teil[12,1,1]:=16;
  teil[12,2,1]:=72;
  teil[12,3,1]:=1;
  teil[12,4,1]:=1;
  teil[12,5,1]:=1;
  teil[12,1,2]:=10;
  teil[12,2,2]:=73;
  teil[12,3,2]:=74;
  teil[12,4,2]:=16;
  teil[12,5,2]:=16;
  teil[12,1,4]:=10;
  teil[12,2,4]:=75;
  teil[12,3,4]:=76;
  teil[12,4,4]:=17;
  teil[12,5,4]:=17;
  teil[12,1,5]:=17;
  teil[12,2,5]:=77;
  teil[12,3,5]:=1;
  teil[12,4,5]:=1;
  teil[12,5,5]:=1;
  teil[14,1,1]:=1;
  teil[14,2,1]:=1;
  teil[14,3,1]:=1;
  teil[14,4,1]:=78;
  teil[14,5,1]:=16;
  teil[14,1,2]:=16;
  teil[14,2,2]:=16;
  teil[14,3,2]:=79;
  teil[14,4,2]:=80;
  teil[14,5,2]:=10;
  teil[14,1,4]:=17;
  teil[14,2,4]:=17;
  teil[14,3,4]:=81;
  teil[14,4,4]:=82;
  teil[14,5,4]:=10;
  teil[14,1,5]:=1;
  teil[14,2,5]:=1;
  teil[14,3,5]:=1;
  teil[14,4,5]:=83;
  teil[14,5,5]:=17;
  level:=nlevel;
  str(level,hs);
  assign(f,lw+'lev'+hs+'.map');
  {$I-}
  reset(f);
  {$I+}
  if ioresult<>0 then
   begin
    loadlevel:=false;
    exit;
   end;
  loadlevel:=true;
  for i:=1 to 20 do
   for j:=1 to 20 do
    read(f,feld2[i,j]);
  close(f);
  fanz:=0;
  for i:=1 to 20 do
   for j:=1 to 20 do
    begin
     mfeld[i,j]:=0;
     for k:=1 to 5 do
      for l:=1 to 5 do
       feld[i*5-5+k,j*5-5+l]:=teil[feld2[i,j],k,l];
     if feld2[i,j] in [2..11] then
      begin
       inc(fanz);
       mfeld[i,j]:=1;
      end;
     if feld2[i,j] in [8..11] then
      begin
       nhx:=i*5-5+3;
       nhy:=j*5-5+3;
       if feld2[i,j]=8 then ri:=1;
       if feld2[i,j]=9 then ri:=9;
       if feld2[i,j]=10 then ri:=5;
       if feld2[i,j]=11 then ri:=13;
      end;
    end;
  hx:=nhx;
  hy:=nhy;
  if hx>7 then anfx:=hx-7
          else anfx:=1;
  if hy>7 then anfy:=hy-7
          else anfy:=1;
  if anfx>86 then anfx:=86;
  anx:=anfx*16-16;
  any:=anfy*16-16;
  dx:=0;
  dy:=0;
  zx:=0;
  zy:=0;
  sprung:=false;
  smz:=0;
  x:=hx*16-16;
  y:=hy*16-16;
  rx:=x-anfx*16;
  ry:=y-anfy*16;
  rcount:=0;
  bonus:=false;
  bewz:=1;
  aus:=false;
  tuerrein:=0;
  leveldone:=false;
  manz:=2;
  for i:=1 to manz do
   begin
    monster[i].da:=true;
    monster[i].art:=17;
    repeat
     hhx:=random(100)+1;
     hhy:=random(100)+1;
    until feld[hhx,hhy]=10;
    monster[i].x:=hhx*16-16;
    monster[i].y:=hhy*16-16;
   end;
  actnote:=0;
  music:=false;
  actmusic:=0;
  bz1:=0;
  bz2:=0;
 end;

{******************* Editor ************************************************}

procedure edit;
type tepic=array [1..104] of byte;
var level:byte;
    f:file of byte;
    efeld:array [1..20,1..20] of byte;
    epic:array [1..14] of tepic;
    i,j,x,y,wahl:byte;
 begin
  graphseg:=page2;
  putimage(0,0,pic[1]);
  getimage(3,3,12,12,epic[1]);
  for i:=1 to 10 do
   begin
    putimage(0,0,pic[57+i]);
    getimage(3,3,12,12,epic[i+1]);
   end;
  for i:=1 to 3 do
   begin
    putimage(0,0,pic[83+i]);
    getimage(3,3,12,12,epic[11+i]);
   end;
  graphseg:=$a000;
  level:=1;
  repeat
   str(level,hs);
   printxy(0,50,15,31,'Level:'+hs);
   warten(a);
   if a=#0 then
    begin
     a:=readkey;
     if a=#72 then inc(level);
     if a=#80 then dec(level);
    end;
  until a=#13;
  str(level,hs);
  assign(f,lw+'lev'+hs+'.map');
  {$I-}
  reset(f);
  {$I+}
  if ioresult<>0 then
   begin
    for i:=1 to 20 do
     for j:=1 to 20 do
      efeld[i,j]:=1;
   end
   else
   begin
    for i:=1 to 20 do
     for j:=1 to 20 do
      read(f,efeld[i,j]);
    close(f);
   end;
  for i:=1 to 20 do
   for j:=1 to 20 do
    putimage(i*10-10,j*10-10,epic[efeld[i,j]]);
  x:=1;
  y:=1;
  wahl:=2;
  putimage(x*10-10,y*10-10,epic[wahl]);
  repeat
   warten(a);
   case a of
    '+':begin
         inc(wahl);
         if wahl>14 then wahl:=1;
         putimage(x*10-10,y*10-10,epic[wahl]);
        end;
    '-':begin
         dec(wahl);
         if wahl=0 then wahl:=14;
         putimage(x*10-10,y*10-10,epic[wahl]);
        end;
    ' ':begin
         efeld[x,y]:=wahl;
        end;
    #0:begin
        a:=readkey;
        case a of
         #60:begin
              assign(f,lw+'lev'+hs+'.map');
              rewrite(f);
              for i:=1 to 20 do
               for j:=1 to 20 do
                write(f,efeld[i,j]);
              close(f);
             end;
         #72:if y>1 then
              begin
               putimage(x*10-10,y*10-10,epic[efeld[x,y]]);
               dec(y);
               putimage(x*10-10,y*10-10,epic[wahl]);
              end;
         #75:if x>1 then
              begin
               putimage(x*10-10,y*10-10,epic[efeld[x,y]]);
               dec(x);
               putimage(x*10-10,y*10-10,epic[wahl]);
              end;
         #77:if x<20 then
              begin
               putimage(x*10-10,y*10-10,epic[efeld[x,y]]);
               inc(x);
               putimage(x*10-10,y*10-10,epic[wahl]);
              end;
         #80:if y<20 then
              begin
               putimage(x*10-10,y*10-10,epic[efeld[x,y]]);
               inc(y);
               putimage(x*10-10,y*10-10,epic[wahl]);
              end;
         end;
       end;
    end;
  until a=#27;
 end;

{ ***************** Zeitnehmung ********************************************}

procedure nimmzeit(var actzeit:longint);
var h,m,s,sec100:word;
 begin
  gettime(h,m,s,sec100);
  actzeit:=sec100+s*100+m*6000;
 end;

{ ***************** Zeitvergleich ******************************************}

procedure vergleichzeit(anfzeit:longint);
var min,sec,sec100:word;
    hs,hs2,hs3:string;
    zeit:longint;
 begin
  nimmzeit(zeit);
  zeit:=zeit-anfzeit;
  min:=zeit div 6000;
  zeit:=zeit mod 6000;
  sec:=zeit div 100;
  zeit:=zeit mod 100;
  sec100:=zeit;
  strr2(min,hs,2);
  strr2(sec,hs2,2);
  strr2(sec100,hs3,2);
  graphseg:=$a000;
  printxy(240,40,15,209,hs+':'+hs2+':'+hs3);
  graphseg:=page2;
 end;

{ ***************** 2. Teil vom Bildaufbau *********************************}

procedure second_part;
 begin
  explosions;
  putbg(rx+38,ry,people[playerpic]^);
  crashtest;
  makescreen;
  if score<>oscore then
   begin
    strr(score,hs,8);
    printt(240,84,15,208,hs);
    oscore:=score;
   end;
  if music then
   begin
    nosound;
    inc(actnote);
    if musics[actmusic,actnote]=255 then
     begin
      music:=false;
      actnote:=0;
      actmusic:=0;
     end
     else sound(44*musics[actmusic,actnote]);
   end;
  wait(60000);
 end;

{ ****************** Spielersteuerung **************************************}

procedure player;
var hs2,hs3,hs:string;
    hv:byte;
    min,sec,sec100:word;
    zeit:longint;
 begin
  be:=false;
  if dreh>0 then dec(dreh);
  if gasz>0 then dec(gasz);
  if bremsz>0 then dec(bremsz);

  if not schleudern then
   if (buttonpressed[72]) and (not buttonpressed[80]) and (gas<maxgas) and (not auslauf) then
    begin
     starten:=true;
     if gasz=0 then
      begin
       inc(gas);
       gasz:=gasmax;
      end;
    end
    else
    if (gas>0) and (bremsz=0) then
     begin
      dec(gas);
      bremsz:=bremsmax;
     end;

  if schleudern then
   begin
    dec(schleudergas);
    gas:=schleudergas;
    inc(playerpic,2);
    if playerpic>16 then dec(playerpic,16);
    if playerpic=0 then playerpic:=1;
    ri:=schleuderri;
    if gas=0 then
     begin
      schleudern:=false;
      ri:=playerpic;
     end;
   end;

  zdx:=(rix[ri]*gas) div 10;
  if ddx>zdx then
   begin
    dec(ddx,unt[gas]);
    if ddx<zdx then ddx:=zdx;
   end
   else
   if ddx<zdx then
    begin
     inc(ddx,unt[gas]);
     if ddx>zdx then ddx:=zdx;
    end;
  inc(x,ddx);
  inc(dx,ddx);
  inc(anx,ddx);
  dec(zx,ddx);
  if zx<0 then
   begin
    inc(zx,16);
    inc(anfx);
   end;
  if zx>15 then
   begin
    dec(zx,16);
    dec(anfx);
   end;
  if dx>=16 then dec(dx,16);
  if dx<0 then inc(dx,16);

  zdy:=(riy[ri]*gas) div 10;
  if ddy>zdy then
   begin
    dec(ddy,unt[gas]);
    if ddy<zdy then ddy:=zdy;
   end
   else
   if ddy<zdy then
    begin
     inc(ddy,unt[gas]);
     if ddy>zdy then ddy:=zdy;
    end;
  inc(y,ddy);
  inc(dy,ddy);
  inc(any,ddy);
  dec(zy,ddy);
  if zy<0 then
   begin
    inc(zy,16);
    inc(anfy);
   end;
  if dy>=16 then dec(dy,16);
  if zy>15 then
   begin
    dec(zy,16);
    dec(anfy);
   end;
  if dy<0 then inc(dy,16);
  if (abs(zdx-ddx)>4) or (abs(zdy-ddy)>4) then
   if gas>3 then muse(5);

  if not schleudern then
   begin

    if (buttonpressed[75]) and (not buttonpressed[77]) and (dreh=0) then
     begin
      inc(ri);
      if ri=17 then ri:=1;
      dreh:=drehmax;
     end;

    if (buttonpressed[77]) and (not buttonpressed[75]) and (dreh=0) then
     begin
      dec(ri);
      if ri=0 then ri:=16;
      dreh:=drehmax;
     end;

   end;

  if not schleudern then playerpic:=ri;
  nosound;
  if not schleudern then
   if not drauf((x+24) div 16,(y+8) div 16+1) then
     begin
      muse(2);
      if gas>maxgas-2 then gas:=maxgas-2;
      if gas>3 then inc(schleuderz);
      if schleuderz=schleudermax then
       begin
        muse(3);
        schleudern:=true;
        schleudergas:=gas+1;
        schleuderri:=ri;
        schleuderz:=0;
       end;
     end
     else
     if schleuderz>0 then dec(schleuderz);

  if mfeld[(x+24) div 80+1,(y+24) div 80+1]=1 then
   if ((feld2[(x+24) div 80+1,(y+24) div 80+1] in [8..11]) and (mfanz>0)) or
      ((feld2[(x+24) div 80+1,(y+24) div 80+1] in [2..7])) then
   begin
    mfeld[(x+24) div 80+1,(y+24) div 80+1]:=2;
    inc(mfanz);
   end;
  if trunc(fanz*0.95)<=mfanz then
   if feld2[(x+24) div 80+1,(y+24) div 80+1] in [8..11] then
    begin
     nimmzeit(zeit);
     laptime:=zeit;
     lapzeit[lap]:=laptime;
     inc(lap);
     if lap>maxlaps then auslauf:=true;
     nimmzeit(zeit);
     laptime:=zeit;
     zeit:=zeit-anfzeit;
     min:=zeit div 6000;
     zeit:=zeit mod 6000;
     sec:=zeit div 100;
     zeit:=zeit mod 100;
     sec100:=zeit;
     strr2(min,hs,2);
     strr2(sec,hs2,2);
     strr2(sec100,hs3,2);
     graphseg:=$a000;
     printxy(240,60,15,209,hs+':'+hs2+':'+hs3);
     anfzeit:=laptime;
     strr(lap,hs,2);
     if not auslauf then printxy(260,20,15,209,hs);
     graphseg:=page2;
     mfanz:=0;
     for i:=1 to 20 do
      for j:=1 to 20 do
       if mfeld[i,j]=2 then mfeld[i,j]:=1;
    end;
 end;

{ ****************** Spieler tot *******************************************}

procedure kaputt;
 begin
  inc(ddy);
  kmz:=(kmz+1) mod 4;
  playerpic:=43+kmz;
  inc(x,ddx);
  inc(y,ddy);
  inc(rx,ddx);
  inc(ry,ddy);
  if y-any>=196 then aus:=true;
 end;

{ ****************** Spiel *************************************************}

procedure play;
var ok:boolean;
 begin
  level:=1;
  score:=0;
  oscore:=0;
  box(0,0,319,199,0);
  graphseg:=page2;
  box(0,0,319,199,0);
  graphseg:=$a000;
  initmanykey;
  ok:=loadlevel(level);
  if not ok then exit;
  graphseg:=page2;
  loadimage(0,0,lw+'main.vpc');
  graphseg:=$a000;
  copyimagefast(0,0,159,199,page2,$a000);
  kmz:=0;
  ganzaus:=false;
  tot:=false;
  gas:=0;
  mfanz:=0;
  schleuderri:=ri;
  schleuderz:=0;
  runt:=0;
  health:=8;
  treffer:=0;
  shot:=0;
  blink:=0;
  dreh:=0;
  gasz:=0;
  bremsz:=0;
  playerpic:=1;
  schleudergas:=0;
  lap:=1;
  laptime:=0;
  auslauf:=false;
  printxy(240,40,15,209,'00:00:00');
  printxy(230,50,15,209,'Last Lap Time');
  printxy(240,60,15,209,'00:00:00');
  strr(lap,hs,2);
  printxy(260,20,15,209,hs);
  zdx:=0;
  zdy:=0;
  nimmzeit(anfzeit);
  starten:=false;
  repeat
   repeat
    start;
    if tot then kaputt
           else player;
    makepic(anfx,zx,anfy,zy);
    if starten then vergleichzeit(anfzeit);
    otherpeople;
    second_part;
    if (auslauf) and (gas=0) then aus:=true;
   until (buttonpressed[1]) or (aus) or (ganzaus);
   if aus then
    begin
     inc(level);
     ok:=loadlevel(level);
     if ok then
      begin
       gas:=0;
       mfanz:=0;
       schleuderri:=ri;
       schleuderz:=0;
       runt:=0;
       health:=8;
       treffer:=0;
       shot:=0;
       blink:=0;
       dreh:=0;
       gasz:=0;
       bremsz:=0;
       playerpic:=1;
       schleudergas:=0;
       lap:=1;
       laptime:=0;
       auslauf:=false;
       printxy(240,40,15,209,'00:00:00');
       printxy(230,50,15,209,'Last Lap Time');
       printxy(240,60,15,209,'00:00:00');
       strr(lap,hs,2);
       printxy(260,20,15,209,hs);
       nimmzeit(anfzeit);
       starten:=false;
       aus:=false;
      end;
    end;
  until (buttonpressed[1]) or (tot) or (aus) or (ganzaus);
  nosound;
  graphseg:=page2;
  loadimage(10,10,lw+'gameover.vpc');
  graphseg:=$a000;
  copyimagefast(10,10,115,178,page2,$a000);
  repeat
  until buttonpressed[57];
  reinitmanykey;
 end;

{******************* Hauptprogramm *****************************************}

begin
 init;
 repeat
  printt(0,0,15,255,'P PLAY');
  printt(0,10,15,255,'E EDIT');
  printt(0,20,15,255,'Q QUIT');
  warten(a);
  if a='p' then play;
  if a='e' then edit;
 until a='q';
 lastmode;
end.